$(function() {

  function shrinkit(sect) {
    var curr_node = sect.addClass('shrunksect').next();
    if (curr_node.length == 0) {
      //no need to addClass
      sect.removeClass('shrunksect');
      return;
    }
    var icon = '<img src="'
                + Drupal.settings.shrinksections.basepath
                + '/images/plus.png" id="shrinksections_pluspng" />';
    sect.append(icon);

    var thislevel = sect[0].tagName[1];
    while (curr_node.length == 1) {
      var tagname = curr_node[0].tagName;
      if (tagname[0] == 'H' && tagname[1] <= thislevel) {
        break;
      }
      curr_node = curr_node.fadeOut('slow').next();
      //curr_node = curr_node.addClass('shrinksections-closed').next();
    }
  }

  function expandit(sect) {
    var curr_node = sect.removeClass('shrunksect').next();
    var thislevel = sect[0].tagName[1];
    while (curr_node.length == 1) {
      var tagname = curr_node[0].tagName;
      if (tagname[0] == 'H' && tagname[1] <= thislevel) {
        break;
      }
      curr_node = curr_node.fadeIn('slow').next();
      //curr_node = curr_node.removeClass('shrinksections-closed').next();
    };

    sect.find('#shrinksections_pluspng').remove();
  }

  $('.node > .content h2, .node > .content h3, .node > .content h4, .node > .content h5, .node > .content h6').click(function(event2) {
    if ($(this).hasClass('shrunksect')) {
      expandit($(this));
    }
    else {
      shrinkit($(this));
    }
    event2.stopPropagation();
  });

  $('.node>.content *:not(h2,h3,h4,h5,h6)').dblclick(function(event1){
    function search_up(current) {
      var p = current.prevAll('h2,h3,h4,h5,h6');
      if (p.length == 0) {
        return false;
      } else {
        return $(p[0]);
      }
    }

    var result = search_up($(this));
    if (result) {
      shrinkit(result);
    } else {
      var pp = $(this).parents();
      for (var i=0; i<pp.length; i++) {
        if ($(pp[i]).hasClass('content')) {
          break;
        }
        result = search_up($(pp[i]));
        if (result) {
          shrinkit(result);
          break;
        }
      }
    }
    event1.stopPropagation();
  });

  if (Drupal.settings.shrinksections.defaultshrink != 'none') {
    var dl = $('.content h' + Drupal.settings.shrinksections.defaultshrink);
    for (var i=0; i<dl.length; i++) {
      shrinkit(dl.eq(i));
    }
  }

});
